[JLOI2014]松鼠的新家 洛谷P3258
阿新 • • 發佈:2018-10-28
表示 long int fin 整數 return left 思路 pac
所以輸出答案時減掉
題目鏈接
題目描述
松鼠的新家是一棵樹,前幾天剛剛裝修了新家,新家有n個房間,並且有n-1根樹枝連接,每個房間都可以相互到達,且倆個房間之間的路線都是唯一的。天哪,他居然真的住在”樹“上。 松鼠想邀請小熊維尼前來參觀,並且還指定一份參觀指南,他希望維尼能夠按照他的指南順序,先去a1,再去a2,......,最後到an,去參觀新家。可是這樣會導致維尼重復走很多房間,懶惰的維尼不停地推辭。可是松鼠告訴他,每走到一個房間,他就可以從房間拿一塊糖果吃。 維尼是個饞家夥,立馬就答應了。現在松鼠希望知道為了保證維尼有糖果吃,他需要在每一個房間各放至少多少個糖果。 因為松鼠參觀指南上的最後一個房間an是餐廳,餐廳裏他準備了豐盛的大餐,所以當維尼在參觀的最後到達餐廳時就不需要再拿糖果吃了。
輸入輸出格式
輸入格式:
第一行一個整數n,表示房間個數第二行n個整數,依次描述a1-an
接下來n-1行,每行兩個整數x,y,表示標號x和y的兩個房間之間有樹枝相連。
輸出格式:
一共n行,第i行輸出標號為i的房間至少需要放多少個糖果,才能讓維尼有糖果吃。
數據範圍:
2<= n <=300000
樣例
樣例一輸入:
5
1 4 5 3 2
1 2
2 4
2 3
4 5
樣例一輸出:
1
2
1
2
1
思路
1.樹上差分
很明顯的樹上差分裸題,求出 $ A_{i} $ 和 $ A_{i+1} $ 的 $ lca $ 後點差分去做
就是需要註意 $ A_{i} \left( i \neq 1 \right) $ 會重復計算一次
#include <algorithm> #include <iostream> #include <cstring> #include <cstdio> #include <cmath> #include <queue> #include <list> #include <map> #define ll long long #define ull unsigned long long using namespace std; const int mx_n = 300010; int n; int a[mx_n-1]; int w[mx_n]; int ans[mx_n]; int fa[mx_n][20],dep[mx_n]; int h[mx_n],to[mx_n<<1],nx[mx_n<<1],cnt; inline void add(int f,int t) { nx[++cnt] = h[f]; h[f] = cnt; to[cnt] = t; nx[++cnt] = h[t]; h[t] = cnt; to[cnt] = f; } void dfs(int x) { for(int i = h[x]; i; i = nx[i]) if(to[i] != fa[x][0]) { fa[to[i]][0] = x; dep[to[i]] = dep[x] + 1; dfs(to[i]); } } int LCA(int x,int y) { if(dep[x] < dep[y]) swap(x,y); for(int i = 19; i >= 0; i--) if(dep[fa[x][i]] >= dep[y]) x = fa[x][i]; if(x == y) return x; for(int i = 19; i >= 0; i--) if(fa[x][i] != fa[y][i]) { x = fa[x][i]; y = fa[y][i]; } return fa[x][0]; } int deal(int x) { int now = w[x]; for(int i = h[x]; i; i = nx[i]) if(to[i] != fa[x][0]) { now += deal(to[i]); } ans[x] = now; return now; } int main() { // freopen("testdata.in","r",stdin); // freopen("1.out","w",stdout); int c,b; scanf("%d",&n); for(int i = 1; i <= n; i++) { scanf("%d",&a[i]); } for(int i = 1; i < n; i++) { scanf("%d%d",&c,&b); add(c,b); } add(0,1); dfs(0); for(int i = 1; i <= 19; i++) for(int j = 1; j <= n; j++) fa[j][i] = fa[fa[j][i-1]][i-1]; for(int i = 1; i < n; i++) { int x = a[i], y = a[i+1]; int lca = LCA(x,y); w[lca]--; // cout << lca << '+' << endl; w[x]++; w[y]++; w[fa[lca][0]]--; } deal(0); for(int i = 1; i <= n; i++) { printf("%d\n",i == a[1] ? ans[i] : ans[i]-1); } }
[JLOI2014]松鼠的新家 洛谷P3258